#ifndef MKF_DEFINITION_HPP_INCLUDED
#define MKF_DEFINITION_HPP_INCLUDED


#include"mkf_element.hpp"
#include"mkf_identifier.hpp"
#include"mkf_print.hpp"


namespace mkf{


class
Definition
{
  Identifier  identifier;

  ElementList  elements;

  int  separator;

  void  scan(const char*&  p);

public:
  Definition(const char*  id="");
  Definition(const Definition&   rhs);
  Definition(      Definition&&  rhs);


  Definition&  operator=(const Definition&   rhs);
  Definition&  operator=(      Definition&&  rhs);

  void  clear();

  void  append_element(Element&&  el);

  const ElementList&  get_list() const;

  void  reset(const char*&  p);

  void  change_identifier(const char*  s);

  const Identifier&  get_identifier() const;

  void  change_separator(int  sep);
  int   get_separator() const;

  void  print(Printer&  pr) const;

};


}


#endif




