#ifndef MKF_NODE_HPP_INCLUDED
#define MKF_NODE_HPP_INCLUDED


#include"mkf_definition.hpp"
#include"mkf_print.hpp"


namespace mkf{


struct
Node
{
  Node*  parent;

  const char*  defname;

  int  depth;

  std::vector<Node*>  children;

  int  character;

   Node(const char*  defname_="", int  c=0);
   Node(Node&&  rhs);
  ~Node();


  bool  operator==(const char*  name) const;

  void  append(Node*  child);

  Node*  release_unique_child();

  int  scan_string(char*  buf, size_t  n) const;

  void  print(            ) const;
  void  print(Printer&  pr) const;

};


}


#endif




